<?xml version="1.0" encoding="UTF-8"?>
<!--

CodeSense Libraries simply define lists of completions, categorized by keys. They don't define any criteria for when they should be used; this is the domain of a CodeSense Provider.

-->
<codesense version="1.0">

	<behavior>
		<append-dynamic>
			<matched-suffix>(\s*=)|[^=]</matched-suffix>
			<transform-into>(?1::="$1"$0)</transform-into>
		</append-dynamic>
	</behavior>
	
	<set name="com.macrabbit.html.tag.standard-attributes">
		<completion string="id" />
		<completion string="class" />
		<completion string="title" />
		<completion string="style" />
		<completion string="tabindex" />
		<completion string="accesskey" />
		<!-- HTML 5 -->
		<completion string="contenteditable" />
		<completion string="contextmenu" />
		<completion string="dir" />
		<completion string="draggable" />
		<completion string="itemid" />
		<completion string="itemprop" />
		<completion string="itemref" />
		<completion string="itemscope" />
		<completion string="itemtype" />
		<completion string="hidden" />
		<completion string="lang" />
		<completion string="role" />
		<completion string="spellcheck" />
	</set>
	
	<set name="com.macrabbit.html.tag.event-attributes">
		<completion string="onblur" />
		<completion string="onchange" />
		<completion string="onclick" />
		<completion string="ondblclick" />
		<completion string="onfocus" />
		<completion string="onkeydown" />
		<completion string="onkeypress" />
		<completion string="onkeyup" />
		<completion string="onload" />
		<completion string="onmousedown" />
		<completion string="onmousemove" />
		<completion string="onmouseout" />
		<completion string="onmouseover" />
		<completion string="onmouseup" />
		<completion string="onmousewheel" />
		<completion string="onsubmit" />
		<!-- HTML 5 -->
		<completion string="onabort" />
		<completion string="oncanplay" />
		<completion string="oncanplaythrough" />
		<completion string="oncontextmenu" />
		<completion string="oncopy" />
		<completion string="oncut" />
		<completion string="ondrag" />
		<completion string="ondragend" />
		<completion string="ondragenter" />
		<completion string="ondragleave" />
		<completion string="ondragover" />
		<completion string="ondragstart" />
		<completion string="ondrop" />
		<completion string="ondurationchange" />
		<completion string="onemptied" />
		<completion string="onended" />
		<completion string="onerror" />
		<completion string="onformchange" />
		<completion string="onforminput" />
		<completion string="oninput" />
		<completion string="oninvalid" />
		<completion string="onloadeddata" />
		<completion string="onloadedmetadata" />
		<completion string="onloadstart" />
		<completion string="onpause" />
		<completion string="onpaste" />
		<completion string="onplay" />
		<completion string="onplaying" />
		<completion string="onprogress" />
		<completion string="onratechange" />
		<completion string="onreadystatechange" />
		<completion string="onreset" />
		<completion string="onresize" />
		<completion string="onscroll" />
		<completion string="onseeked" />
		<completion string="onseeking" />
		<completion string="onselect" />
		<completion string="onshow" />
		<completion string="onstalled" />
		<completion string="onsuspend" />
		<completion string="ontimeupdate" />
		<completion string="onvolumechange" />
		<completion string="onwaiting" />
	</set>
	
	<set name="com.macrabbit.html.tag.a.attributes">
		<completion string="href" />
		<completion string="hreflang" />
		<completion string="name" />
		<completion string="rel" />
		<completion string="target" />
		<completion string="type" />
		<!-- HTML 5 -->
		<completion string="ping" />
		<completion string="media" />
	</set>
	
	<set name="com.macrabbit.html.tag.applet.attributes">
		<completion string="height" />
		<completion string="width" />
		<completion string="align" />
		<completion string="alt" />
		<completion string="archive" />
		<completion string="code" />
		<completion string="codebase" />
		<completion string="hspace" />
		<completion string="name" />
		<completion string="object" />
		<completion string="vspace" />
	</set>
	
	<set name="com.macrabbit.html.tag.area.attributes">
		<completion string="alt" />
		<completion string="coords" />
		<completion string="href" />
		<completion string="nohref" />
		<completion string="shape" />
		<completion string="target" />
		<!-- HTML 5 -->
		<completion string="ping" />
		<completion string="rel" />
		<completion string="media" />
		<completion string="hreflang" />
		<completion string="type" />
	</set>
	
	<!-- HTML 5 -->
	<set name="com.macrabbit.html.tag.audio.attributes">
		<completion string="src" />
		<completion string="preload" />
		<completion string="autoplay">
			<behavior>
				<append-static></append-static>
			</behavior>
		</completion>
		<completion string="loop">
			<behavior>
				<append-static></append-static>
			</behavior>
		</completion>
		<completion string="controls">
			<behavior>
				<append-static></append-static>
			</behavior>
		</completion>
	</set>
	
	<set name="com.macrabbit.html.tag.base.attributes">
		<completion string="href" />
		<completion string="target" />
	</set>
	
	<set name="com.macrabbit.html.tag.bdo.attributes">
		<completion string="dir" />
	</set>
	
	<set name="com.macrabbit.html.tag.blockquote.attributes">
		<completion string="cite" />
	</set>
	
	<set name="com.macrabbit.html.tag.button.attributes">
		<completion string="disabled" />
		<completion string="name" />
		<completion string="type" />
		<completion string="value" />
		<!-- HTML 5 -->
		<completion string="autofocus" />
		<completion string="form" />
		<completion string="formaction" />
		<completion string="formenctype" />
		<completion string="formmethod" />
		<completion string="formnovalidate" />
		<completion string="formtarget" />
	</set>
	
	<set name="com.macrabbit.html.tag.canvas.attributes">
		<completion string="width" />
		<completion string="height" />
	</set>
	
	<set name="com.macrabbit.html.tag.col.attributes">
		<completion string="align" />
		<completion string="char" />
		<completion string="charoff" />
		<completion string="span" />
		<completion string="valign" />
		<completion string="width" />
	</set>
	
	<set name="com.macrabbit.html.tag.colgroup.attributes">
		<completion string="align" />
		<completion string="char" />
		<completion string="charoff" />
		<completion string="span" />
		<completion string="valign" />
		<completion string="width" />
	</set>
	
	<!-- HTML 5 -->
	<set name="com.macrabbit.html.tag.command.attributes">
		<completion string="type" />
		<completion string="label" />
		<completion string="icon" />
		<completion string="disabled" />
		<completion string="checked" />
		<completion string="radiogroup" />
	</set>
	
	<set name="com.macrabbit.html.tag.del.attributes">
		<completion string="cite" />
		<completion string="datetime" />
	</set>
	
	<!-- HTML 5 -->
	<set name="com.macrabbit.html.tag.details.attributes">
		<completion string="open" />
	</set>
	
	<!-- HTML 5 -->
	<set name="com.macrabbit.html.tag.device.attributes">
		<completion string="type" />
	</set>
	
	<set name="com.macrabbit.html.tag.dir.attributes">
		<completion string="compact" />
	</set>
	
	<!-- HTML 5 -->
	<set name="com.macrabbit.html.tag.embed.attributes">
		<completion string="src" />
		<completion string="type" />
		<completion string="width" />
		<completion string="height" />
	</set>
	
	<!-- HTML 5 -->
	<set name="com.macrabbit.html.tag.fieldset.attributes">
		<completion string="disabled" />
		<completion string="form" />
		<completion string="name" />
	</set>
	
	<!-- HTML 5 -->
	<set name="com.macrabbit.html.tag.form.attributes">
		<completion string="accept-charset" />
		<completion string="action" />
		<completion string="autocomplete" />
		<completion string="enctype" />
		<completion string="method" />
		<completion string="name" />
		<completion string="novalidate" />
		<completion string="target" />
	</set>
	
	<set name="com.macrabbit.html.tag.frame.attributes">
		<completion string="frameborder" />
		<completion string="longdesc" />
		<completion string="marginheight" />
		<completion string="marginwidth" />
		<completion string="name" />
		<completion string="noresize" />
		<completion string="scrolling" />
		<completion string="src" />
	</set>
	
	<set name="com.macrabbit.html.tag.frameset.attributes">
		<completion string="cols" />
		<completion string="rows" />
	</set>
	
	<set name="com.macrabbit.html.tag.head.attributes">
		<completion string="profile" />
	</set>
	
	<set name="com.macrabbit.html.tag.html.attributes">
		<completion string="xmlns" />
		<!-- HTML 5 -->
		<completion string="manifest" />
	</set>
	
	<set name="com.macrabbit.html.tag.iframe.attributes">
		<completion string="align" />
		<completion string="frameborder" />
		<completion string="longdesc" />
		<completion string="marginheight" />
		<completion string="marginwidth" />
		<completion string="name" />
		<completion string="noresize" />
		<completion string="scrolling" />
		<completion string="src" />
		<completion string="width" />
		<completion string="height" />
		<!-- HTML 5 -->
		<completion string="srcdoc" />
		<completion string="sandbox" />
		<completion string="seamless" />
	</set>
	
	<set name="com.macrabbit.html.tag.img.attributes">
		<completion string="alt" />
		<completion string="src" />
		<completion string="height" />
		<completion string="width" />
		<completion string="usemap" />
		<completion string="longdesc" />
		<!-- HTML 5 -->
		<completion string="ismap" />
		<completion string="srcset"/>
	</set>
	
	<set name="com.macrabbit.html.tag.input.attributes">
		<completion string="accept" />
		<completion string="alt" />
		<completion string="checked" />
		<completion string="disabled" />
		<completion string="maxlength" />
		<completion string="name" />
		<completion string="readonly" />
		<completion string="size" />
		<completion string="src" />
		<completion string="type" />
		<completion string="value" />
		<!-- HTML 5 -->
		<completion string="autocomplete" />
		<completion string="autofocus" />
		<completion string="form" />
		<completion string="formaction" />
		<completion string="formenctype" />
		<completion string="formmethod" />
		<completion string="formnovalidate" />
		<completion string="formtarget" />
		<completion string="height" />
		<completion string="list" />
		<completion string="max" />
		<completion string="min" />
		<completion string="multiple" />
		<completion string="pattern" />
		<completion string="placeholder" />
		<completion string="required" />
		<completion string="step" />
		<completion string="width" />
	</set>
	
	<set name="com.macrabbit.html.tag.ins.attributes">
		<completion string="cite" />
		<completion string="datetime" />
	</set>
	
	<!-- HTML 5 -->
	<set name="com.macrabbit.html.tag.keygen.attributes">
		<completion string="autofocus" />
		<completion string="challenge" />
		<completion string="disabled" />
		<completion string="form" />
		<completion string="keytype" />
		<completion string="name" />
	</set>
	
	<set name="com.macrabbit.html.tag.label.attributes">
		<completion string="for" />
		<!-- HTML 5 -->
		<completion string="form" />
	</set>
	
	<!-- HTML 5 -->
	<set name="com.macrabbit.html.tag.li.attributes">
		<completion string="value" />
	</set>
	
	<set name="com.macrabbit.html.tag.link.attributes">
		<completion string="charset" />
		<completion string="href" />
		<completion string="hreflang" />
		<completion string="media" />
		<completion string="rel" />
		<completion string="rev" />
		<completion string="target" />
		<completion string="type" />
		<!-- HTML 5 -->
		<completion string="sizes" />
	</set>
	
	<set name="com.macrabbit.html.tag.map.attributes">
		<completion string="name" />
	</set>
	
	<!-- HTML 5 -->
	<set name="com.macrabbit.html.tag.menu.attributes">
		<completion string="label" />
		<completion string="type" />
	</set>
	
	<set name="com.macrabbit.html.tag.meta.attributes">
		<completion string="http-equiv" />
		<completion string="content" />
		<completion string="name" />
		<completion string="scheme" />
		<!-- HTML 5 -->
		<completion string="charset" />
	</set>
	
	<!-- HTML 5 -->
	<set name="com.macrabbit.html.tag.meter.attributes">
		<completion string="form" />
		<completion string="high" />
		<completion string="low" />
		<completion string="max" />
		<completion string="min" />
		<completion string="optimum" />
		<completion string="value" />
	</set>
	
	<set name="com.macrabbit.html.tag.object.attributes">
		<completion string="align" />
		<completion string="archive" />
		<completion string="border" />
		<completion string="classid" />
		<completion string="codebase" />
		<completion string="codetype" />
		<completion string="data" />
		<completion string="declare" />
		<completion string="height" />
		<completion string="name" />
		<completion string="standby" />
		<completion string="type" />
		<completion string="usemap" />
		<completion string="width" />
	</set>
	
	<!-- HTML 5 -->
	<set name="com.macrabbit.html.tag.ol.attributes">
		<completion string="reversed" />
		<completion string="start" />
	</set>
	
	<set name="com.macrabbit.html.tag.optgroup.attributes">
		<completion string="label" />
		<completion string="disabled" />
	</set>
	
	<set name="com.macrabbit.html.tag.option.attributes">
		<completion string="disabled" />
		<completion string="label" />
		<completion string="selected" />
		<completion string="value" />
	</set>
	
	<!-- HTML 5 -->
	<set name="com.macrabbit.html.tag.output.attributes">
		<completion string="for" />
		<completion string="form" />
		<completion string="name" />
	</set>
	
	<set name="com.macrabbit.html.tag.param.attributes">
		<completion string="name" />
		<completion string="type" />
		<completion string="value" />
		<completion string="valuetype" />
	</set>
	
	<!-- HTML 5 -->
	<set name="com.macrabbit.html.tag.progress.attributes">
		<completion string="max" />
		<completion string="value" />
	</set>
	
	<set name="com.macrabbit.html.tag.q.attributes">
		<completion string="cite" />
	</set>
	
	<set name="com.macrabbit.html.tag.script.attributes">
		<completion string="type" />
		<completion string="charset" />
		<completion string="defer" />
		<completion string="language" />
		<completion string="src" />
		<!-- HTML 5 -->
		<completion string="async" />
	</set>
	
	<set name="com.macrabbit.html.tag.select.attributes">
		<completion string="disabled" />
		<completion string="multiple" />
		<completion string="name" />
		<completion string="size" />
		<!-- HTML 5 -->
		<completion string="autofocus" />
		<completion string="form" />
	</set>
	
	<!-- HTML 5 -->
	<set name="com.macrabbit.html.tag.source.attributes">
		<completion string="media" />
		<completion string="src" />
		<completion string="type" />
	</set>
	
	<set name="com.macrabbit.html.tag.style.attributes">
		<completion string="type" />
		<completion string="media" />
		<!-- HTML 5 -->
		<completion string="scoped" />
		<completion string="title" />
	</set>
	
	<set name="com.macrabbit.html.tag.table.attributes">
		<completion string="border" />
		<completion string="cellpadding" />
		<completion string="cellspacing" />
		<completion string="height" />
		<completion string="frame" />
		<completion string="rules" />
		<completion string="summary" />
		<completion string="width" />
	</set>
	
	<set name="com.macrabbit.html.tag.tbody.attributes">
		<completion string="char" />
		<completion string="charoff" />
		<completion string="valign" />
	</set>
	
	<set name="com.macrabbit.html.tag.td.attributes">
		<completion string="abbr" />
		<completion string="align" />
		<completion string="axis" />
		<completion string="char" />
		<completion string="charoff" />
		<completion string="colspan" />
		<completion string="headers" />
		<completion string="height" />
		<completion string="rowspan" />
		<completion string="scope" />
		<completion string="valign" />
		<completion string="width" />
	</set>
	
	<set name="com.macrabbit.html.tag.textarea.attributes">
		<completion string="cols" />
		<completion string="rows" />
		<completion string="disabled" />
		<completion string="name" />
		<completion string="readonly" />
		<!-- HTML 5 -->
		<completion string="autofocus" />
		<completion string="form" />
		<completion string="maxlength" />
		<completion string="placeholder" />
		<completion string="required" />
		<completion string="wrap" />
	</set>
	
	<set name="com.macrabbit.html.tag.tfoot.attributes">
		<completion string="char" />
		<completion string="charoff" />
		<completion string="valign" />
	</set>
	
	<set name="com.macrabbit.html.tag.th.attributes">
		<completion string="abbr" />
		<completion string="axis" />
		<completion string="char" />
		<completion string="charoff" />
		<completion string="colspan" />
		<completion string="headers" />
		<completion string="height" />
		<completion string="rowspan" />
		<completion string="scope" />
		<completion string="valign" />
		<completion string="width" />
	</set>
	
	<set name="com.macrabbit.html.tag.thead.attributes">
		<completion string="char" />
		<completion string="charoff" />
		<completion string="valign" />
	</set>
	
	<!-- HTML 5 -->
	<set name="com.macrabbit.html.tag.time.attributes">
		<completion string="datetime" />
		<completion string="pubdate">
			<behavior>
				<append-static></append-static>
			</behavior>
		</completion>
	</set>
	
	<set name="com.macrabbit.html.tag.tr.attributes">
		<completion string="char" />
		<completion string="charoff" />
		<completion string="valign" />
	</set>
	
	<!-- HTML 5 -->
	<set name="com.macrabbit.html.tag.track.attributes">
		<completion string="kind" />
		<completion string="label" />
		<completion string="src" />
		<completion string="srclang" />
	</set>
	
	<!-- HTML 5 -->
	<set name="com.macrabbit.html.tag.video.attributes">
		<completion string="autoplay">
			<behavior>
				<append-static></append-static>
			</behavior>
		</completion>
		<completion string="controls">
			<behavior>
				<append-static></append-static>
			</behavior>
		</completion>
		<completion string="height" />
		<completion string="loop" />
		<completion string="poster" />
		<completion string="preload" />
		<completion string="src" />
		<completion string="width" />
	</set>
	
</codesense>
